#include <thread>
#include <mutex>
#include <iostream>
#include "thread_with_lambda.hpp"


namespace {

std::mutex my_mutex;
std::thread worker;

}

void thread_with_lambda()
{
    uint32_t ticks = 10;
    std::lock_guard<std::mutex> lock(my_mutex);

    worker = std::thread([=]{
        for(uint32_t tick = 0; tick <= ticks; tick++) {
            std::cout << __PRETTY_FUNCTION__ << " count " << tick << std::endl;
        }
    });
    if (worker.joinable()) worker.join();
}
